program TM;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows;

var
  hCom:THandle;
  CisloPortu:String;

procedure Otevreni_Serioveho_Portu;
var
  paCh:PAnsiChar;
  dcb:_DCB;
begin
// Chceme-li u systmu Windows NT pouvat porty vy ne COM9 je teba
// tento port specifikovat pomoc UNC cesty specifikujc zazen v systmu.
// standartn nazev seriovho portu:    "COM1"
// odpovidajc port zapsan pomoc UNC: "\\.\COM1"

  paCh:=PChar('\\.\COM'+CisloPortu);

{ CreateFile - http://msdn.microsoft.com/library/default.asp?url=/library/en-us/fileio/fs/createfile.asp }
  hCom:=CreateFile(
    paCh,                            // jmeno souboru - nzev sriovho portu
    GENERIC_READ,                    // pstup - teni i zpis
    0,                               // sdlen - exclusivni pstup
    0,                               // atributy zabezpeen
    OPEN_EXISTING,                   // zpsob vytvoen
    0,                               // atributy souboru
    0                                // soubor "ablony"
   );

  if (hCom = INVALID_HANDLE_VALUE)   // pokud se nepodailo otevt komunikan port
   then raise Exception.Create(Format('Port nelze otevt. Chyba %d',[GetLastError]));

  if GetCommState(hCom,dcb) then     // peten aktulnho nastaven sriovho portu
  begin
    dcb.BaudRate := CBR_9600;        // rychlost
    dcb.ByteSize := 8;               // bit
    dcb.Parity   := NOPARITY;        // bez parity
    dcb.StopBits := ONESTOPBIT;      // jeden stopbit

    if not SetCommState(hCom,dcb)    // nastaven parametr sriovho portu
     then raise Exception.Create(Format('Nelze nastavit port. Chyba ',[GetLastError]));
  end;
end;

function Precti_seriovy_port: String;
var
  lpErrors:Cardinal;
  lpStat:PComStat;
  W:Cardinal;
begin
  Result:='';
  try
    if hCom<>INVALID_HANDLE_VALUE then
    begin
      ClearCommError(hCom,lpErrors,lpStat);          // Zjistn aktulnho stavu sriovho portu
      SetLength(result,lpStat.cbInQue);              // Nastaven velikosti nvratovho etzce
      ReadFile(hCom,result[1],lpStat.cbInQue,W,nil); // Naten etzce z pijmacho bufferu

      If W<>lpStat.cbInQue                           // Oznut vslednho etzce pokud bylo
       then SetLength(result,W);                     // vyteno mn dat ne bylo oekvno
    end;
  except
    Result:='';
  end;
end;

procedure Uzavreni_serioveho_portu;
begin
  if hCom<>INVALID_HANDLE_VALUE then
  begin
    if CloseHandle(hCom)                            // uzaven sriovho portu
     then hCom:=INVALID_HANDLE_VALUE
     else raise Exception.Create('Chyba pi pokusu o zaven sriovho portu.');
  end;
end;

begin
  if ParamCount=0 then                  // pokud nebyla aplikace sputna s parametrem
  begin
    Write('Zadejte slo sriovho portu: COM');
    Readln(CisloPortu);                 // zeptej se na slo poru
    Writeln;
  end
  else CisloPortu:=ParamStr(1);         // je-li parametr - pouzij jej jako slo portu


  try
    Otevreni_Serioveho_Portu;

    sleep(1000);                        // ponechat idlu as pro odmr
    Writeln(Precti_seriovy_port);       // peten pijatch dat

    Uzavreni_Serioveho_Portu;
  except
    on E:Exception do Writeln(E.Message);
  end;

  Writeln;
  Writeln('Pro ukonen aplikace stisnte ENTER!');
  Readln;                               // ekn na enter
end.
